/*                              .. $MMMMMMMMMMMMMN?..... .    
.                       ....IMMMMMMMMMMMMMMMMMMMMMMMMMMM>  
.                      ..MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM8  
.                  .  MMMMMMMMMMM~,..          . ~MMMMMMM.  
.            ....$MMMMMMMMMM,...                    . ...   
..MMMMMMMMMMMMMMMMMMMMMM$...                                
.,MMMMMMMMMMMMMMMMMMZ...              ... ....              
. MMMMMMMMMMM?.               . ..MMMMMMMMMMMMMM .          
.                           ..NMMMMMMMMMMMMMMMMMMM  .       
.                         IMMMMMM,..8MMMMMMMMMM:MMMM,.      
.     .    .. .     ...MMMMMI..   .MMMMMMMMMMM. MMMMM,.    
.MMMMMMMMMMMMMMMMMMMMMMMMMM ..     .MMMMMMMMMMM   ZMMMMM    
.MMMMMMMMMMMMMMMMMMMMMMMMMMM.      .,MMMMMMMMM.   . MMMM   
. :  ... ...       .....=MMMMMMMDI,  .IMMMMMM8NMMMMMMMMMMN  
.                          . .NMMMMMMMMMMMMMMM~         ..  
.                               ....MMMMMMMMM$              
.                                 MMMM= MMMMM:..            
.                              .IMMMM...MMMMMM .            
.      ...                    ?MMM8. . .~MMMM$..            
. ~MMMMMM8                 .MMMMM,.    . MMMM.              
. MMM.MMM                MMMMN.         MMMM.              
..MMM.MMM7          .. MMMMM             MMMM               
..MMMM  .        .. MMMMM .              NMMM.              
. .,MMM7 .   .  MMMMM....               IMMM.              
.    . MMMMMMMMMMM..                      MMM.              
.       ....  ..                         .MMM.              
.                                        .MMM               
.       Horus Audio                      .   .              
*/
/*****************************************************************************/
// Filename     : STA310.c
// Author       : Olivier Swinkels                                           
// Description  : STA310 header file
//                
/*****************************************************************************/


#pragma used+
s8 sta310_init(u8 i2c_addr);
s8 sta310_softReset(u8 i2c_addr);
s8 sta310_syncConf(u8 i2c_addr);
s8 sta310_selectDecoder(u8 i2c_addr, u8 decoder);
u8 sta310_getFs(u8 i2c_addr);
s8 sta310_audioPllConf(u8 i2c_addr,u8 source);
#pragma used-



//defines
#define DEC_PES_DD              0 
#define DEC_PES_MPEG1           1 
#define DEC_PES_MPEG2           2 
#define DEC_PES_DD_DVD          3 
#define DEC_PES_MPEG1_DVD       4 
#define DEC_PES_PCM_DVD         5 
#define DEC_PACKET_MPEG1        6 
#define DEC_ES_DD               7 
#define DEC_ES_MPEG1            8 
#define DEC_ES_MPEG2            9 
#define DEC_ES_PCM              10
#define DEC_PINK_NOISE          11
#define DEC_ES_CDDA             12
#define DEC_BEEP_TONE           13
#define DEC_ES_MP3              14
#define DEC_SPDIF_DD            15
#define DEC_SPDIF_MPEG1         16
#define DEC_SPDIF_MPEG2         17
#define DEC_SPDIF_DTS           18
#define DEC_PES_DVD_AUDIO       19
#define DEC_PES_MPL_DVD_AUDIO   20



#define STREAMSEL               0x4C
#define DECODESEL               0x4D

//macros
//choose auio clock source (system clock is always external crystal)
#define INTERNAL_AUDIO_CLOCK    i2c_write_reg(i2c_addr,0x12,0x02); i2c_write_reg(i2c_addr,0x1D,0x00); // use internal audio PLL 
#define EXTERNAL_AUDIO_CLOCK    i2c_write_reg(i2c_addr,0x12,0x06); i2c_write_reg(i2c_addr,0x1D,0x00); // use external S/P-DIF derived audio clock












// #define VERSION                    0x00
// #define IDENT                      0x01
// #define SOFTVER                    0x71
// #define SIN_SETUP                  0x0C
// #define CAN_SETUP                  0x0D
// #define PCMDIVIDER                 0x54
// #define PCMCONF                    0x55
// #define PCMCROSS                   0x56
// #define SFREQ                      0x05
// #define PLLCTRL                    0x12
// #define PLLMASK                    0x18
// #define DATA IN                    0x0E
// #define PLLCTRL                    0x12
// #define PLL_DATA                   0x11
// #define PLL_CMD                    0x1D
// #define PLL_ADD                    0x12
// #define ENA_ALL FRACPLL           0xB5
// #define AU_PLL_FRACL_192          0xB6
// #define AU_PLL_FRACH_192          0xB7
// #define AU_PLL_XDIV_192           0xB8
// #define AU_PLL_MDIV_192           0xB9
// #define AU_PLL_NDIV_192           0xBA
// #define AU_PLL_FRACL_176          0xBB
// #define AU_PLL_FRACH_176          0xBC
// #define AU_PLL_XDIV_176           0xBD
// #define AU_PLL_MDIV_176           0xBE
// #define LDLY                       0x57
// #define RDLY                       0x58
// #define CDLY                       0x59
// #define SUBDLY                     0x5A
// #define LSDLY                      0x5B
// #define RSDLY                      0x5C
// #define UPDATE                     0x5D
// #define LVDLY                      0xAF
// #define RVDLY                      0xB0
// #define SPDIF_CMD                  0x5E
// #define SPDIF_CAT                  0x5F
// #define SPDIF_CONF                 0x60
// #define SPDIF_STATUS               0x61
// #define SPDIF_REP_TIME            0x75
// #define SPDIF_LATENCY             0x7E
// #define SPDIF_DTDI                0x7F
// #define SOFTRESET                  0x10
// #define PLAY                       0x13
// #define MUTE                       0x14
// #define RUN                       0x72
// #define SKIP_MUTE_CMD             0x73
// #define SKIP_MUTE_VALUE(          0x74
// #define INTE0                      0x07
// #define INTE1                      0x08
// #define INT0                       0x09
// #define INT1                       0x0A
// #define SYNC_STATUS                0x40
// #define ANCCOUNT                   0x41
// #define HEAD4                      0x42
// #define HEAD3                      0x43
// #define HEADLEN                    0x44
// #define PTS                        0x46
// #define ERROR                      0x0F
// #define STREAMSEL                  0x4C
// #define DECODSEL                   0X4D
// #define PACKET_LOCK                0x4F
// #define ID_EN                      0x50
// #define ID                         0x51
// #define ID_EXT                     0x52
// #define SYNC_LOCK                  0x53
// #define PDEC1                      0x62
// #define PDEC2                      0xB1
// #define PL_AB                      0x64
// #define PL_DWNX                    0x65
// #define OCFG                       0x66
// #define DWSMODE                    0x70
// #define VOLUME0                    0x4E
// #define VOLUME1                    0x63
// #define OCFG                       0x66
// #define CHAN_IDX                   0x67
// #define AC3_DECODE_LFE             0x68
// #define AC3_COMP_MOD               0X69
// #define AC3_HDR                    0x6A
// #define AC3_LDR                    0x6B
// #define AC3_RPC                    0x6C
// #define AC3_KARAMODE               0x6D
// #define AC3_DUALMODE               0x6E
// #define AC3_DOWNMIX                0x6F
// #define AC3_STATUS0                0x76
// #define AC3_STATUS1                0x77
// #define AC3_STATUS2                0x78
// #define AC3_STATUS3                0x79
// #define AC3_STATUS4                0x7A
// #define AC3_STATUS5                0x7B
// #define AC3_STATUS6                0x7C
// #define AC3_STATUS7                0x7D
// #define MP_SKIP_LFE                0x68
// #define MP_PROG_NUMBER             0x69
// #define MP_DUALMODE                0x6E
// #define MP_DRC                     0x6A
// #define MP_CRC_OFF                 0x6C
// #define MP_MC_OFF                  0x6D
// #define MP_DOWNMIX                 0x6F
// #define MP_STATUS0                 0x76
// #define MP_STATUS1                 0x77
// #define MP_STATUS2                 0x78
// #define MP_STATUS3                 0x79
// #define MP_STATUS4                 0x7A
// #define MP_STATUS5                 0x7B
// #define PN_DOWNMIX                 0x6F
// #define PCM_BTONE                  0x68
// #define KAR_MCh0VOL                0x81
// #define KAR_MCh1VOL                0x82
// #define KAR_KEYCONT                0x83
// #define KAR_KEYVALUE               0x84
// #define KAR_VCANCEL                0x85
// #define KAR_VVALUE                 0x86
// #define KAR_MMUTE                  0x87
// #define KAR_VCh0VOL                0x88
// #define KAR_VCh1VOL                0x89
// #define KAR_DUET                   0x8A
// #define KAR_DUETTHRESH             0x8B
// #define KAR_VOICE                  0x8C
// #define KAR_VDELAY                 0x8D
// #define KAR_VBAL                   0x8E
// #define KAR_VMUTE                  0x8F
// #define KAR_PLAY                   0x90
// #define KAR_MODE                   0x91
// #define KAR_DIN_CTL                0x92
// #define KAR_UPDATE                 0x93
// #define SFREQ2                     0x94
// #define CANINPUT_MODE              0x95
// #define LPCMA_DOWNMIX              0x6F
// #define LPCMA_FORCE_DWS            0x70
// #define LPCMA_STATUS0              0x76
// #define LPCMA_STATUS1              0x77
// #define LPCMA_STATUS2              0x78
// #define LPCMA_STATUS3              0x79
// #define LPCMA_STATUS4              0x7A
// #define LPCMA_STATUS5              0x7B
// #define LPCMA_DM_COEFT_0           0x97
// #define LPCMA_DM_COEFT_1           0x98
// #define LPCMA_DM_COEFT_2           0x99
// #define LPCMA_DM_COEFT_3           0x9A
// #define LPCMA_DM_COEFT_4           0x9B
// #define LPCMA_DM_COEFT_5           0x9C
// #define LPCMA_DM_COEFT_6           0x9D
// #define LPCMA_DM_COEFT_7           0x9E
// #define LPCMA_DM_COEFT_8           0x9F
// #define LPCMA_DM_COEFT_9           0xA0
// #define LPCMA_DM_COEFT_10          0xA1
// #define LPCMA_DM_COEFT_11          0xA2
// #define LPCMA_DM_COEFT_12          0xA3
// #define LPCMA_DM_COEFT_13          0xA4
// #define LPCMV_DOWNMIX              0x6F
// #define LPCMV_FORCE_DWS            0x70
// #define LPCMV_STATUS0              0x76
// #define LPCMV_STATUS1              0x77
// #define LPCMV_STATUS2              0x78
// #define LPCMV_DM_COEFT_0           0x97
// #define LPCMV_DM_COEFT_1           0x98
// #define LPCMV_DM_COEFT_2           0x99
// #define LPCMV_DM_COEFT_3           0x9A
// #define LPCMV_DM_COEFT_4           0x9B
// #define LPCMV_DM_COEFT_5           0x9C
// #define LPCMV_DM_COEFT_6           0x9D
// #define LPCMV_DM_COEFT_7           0x9E
// #define LPCMV_DM_COEFT_8           0x9F
// #define LPCMV_DM_COEFT_9           0xA0
// #define LPCMV_DM_COEFT_10          0xA1
// #define LPCMV_DM_COEFT_11          0xA2
// #define LPCMV_DM_COEFT_12          0xA3
// #define LPCMV_DM_COEFT_13          0xA4
// #define LPCMV_CH_ASSIGN            0xA8
// #define LPCMV_MULTI_CHS            0xA9
// #define DEEMPH                     0xB5
// #define VCR_MIX                    0xAE
// #define VCR_LDLY                   0xAF
// #define VCR_RDLY                   0xB0
// #define BREAKPOINT                 0x2B
// #define CLOCKCMD                   0x3A
// #define INIT_RAM                   0xFF
// #define AUTODETECT_ENA             0xE0
// #define AUTODETECT_SENS            0xE1
// #define AUTODETECT_ALIGN           0xE2
                         